=== debian/changelog ===
osmium-tool (1.7.1-1) unstable; urgency=medium

  * New upstream release.
  * Bump minimum required libosmium2-dev to 2.13.1.
  * Add patch to fix manpage installation.

 -- Bas Couwenberg <sebastic@debian.org>  Sat, 26 Aug 2017 09:00:12 +0200
